/* dfstream.cc {\documentstyle{jsrc2latex}\rhead{\sl dfstream.cc\quad\thepage}
   \font\tenrm=cmtt10}
{\ \begin{verbatim}
$RCSfile: dfstream.cc,v $  $Revision: 1.1 $ 
$Date: 1996/09/04 01:27:12 $  by KyotoHydro
\end{verbatim}}
{\ {\setlength{\parskip}{4pt}% latex-mode

}% end of latex-mode }
*/

#include <iostream>
#include <stdio.h>
#include <assert.h>
#include "dfstream.h"

using namespace std;   // added on Oct. 4, 2007

void dfstream::open(const char *name) {
	ifstream fi(name);
    if (!fi) {
		setstate(failbit);
		return;
    }
	
	if (!tmpnam(dfname)) {
		setstate(failbit);
		return;
	}
	ofstream fo(dfname);
	if (!fo) {
		setstate(failbit);
		return;
	}
	char c;
	char clast = '\n';
	while (fi.get(c)) {
		if (c == '\'' || c == '\"') {
			char cmt = c;   fo.put(c);
			while (fi.get(c)) {
				fo.put(c);
				if (c == cmt) break;
			}
			assert(c == cmt);
		}
		else if (c == '#') {
			while (fi.get(c)) {
				if (c == '\n') break;
			}
			assert(c == '\n');
			if (clast != '\n') {
				fo.put(c);
			}
		}
	    else {
			fo.put(c);
		}
		clast = c;
	}
	fo.close();
	fi.close();
	cout.flush();
	ifstream::open(dfname);
	openFlag = 1;
}

dfstream::~dfstream() {
	if (openFlag == 1) unlink(dfname);
}

/* end of file {\ % The following part will be omitted in tex file
\begin{comment}\begin{verbatim}
This part is not included in the tex output.
$Revision: 1.1 $

# Local Variables: ***
# tab-width: 4 ***
# End: ***
\end{verbatim}\end{comment}
} */

