/*;  dlist.h {\documentstyle{jsrc2latex}\font\tenrm=cmtt10} */

/*;  $$Revision: 1.2 $$ {\rhead{\sl dlist.h\quad\thepage}} */
/*;  $$Date: 1996/12/02 12:20:11 $$  */
/*;  $$Source: /home/shiiba/96prog/dlist/dlist.h,v $$  */

/*

ΥץϡScott Robert Ladd ˤ C++ Templates and Tools 
˷ǺܤƤץ򸵤ˤƤޤ

Υץϡ㳰(try, throw, catch ʤɤȤ)Υɤ
Ǥޤ̾Υ顼(顼å񤤤ơexit ) 
֤Ƥޤ

ꥹȤ۴Ĥ갷褦ˤʤäƤޤǡ 
Circular  YES ꤵƤϡΥꥹȤϽ۴ĥꥹȤǤǡ
 Circular  YES ꤹˤϡ󥹥ȥ饯ǡDList(YES);
Τ褦ޤ

DList(Boolean circ = NO)
󥹥ȥ饯 YES ꤹȡ۴ĥꥹȡ

DList(const DList<T> & dlst,Boolean shallow = NO
ԡ󥹥ȥ饯ԡλǤޤǤޤǥԡΤ
deep copy.

DList(const T * array, size_t no);
󤫤饳󥹥ȥ饯ȡ

~DList()
ǥȥ饯

*/

//=============================================================
// Doubly-Linked Lists      dlist.h         v1.00
//      Defines templates for classes of doubly-linked lists
//      Copyright 1995 Scott Robert Ladd
//=============================================================

#ifndef DLIST_H
#define DLIST_H

#include "boolean.h"
#include "limits.h"
#include "error.h"

//---------------------
// doubly-linked list
//---------------------

template <class T>
class DList
{
 public:
  // constructors
  DList
  (
   Boolean circ = NO	// ۴ĥꥹȤξϡDList(YES) Ȥޤ
   );
  
  // copy constructor
  DList
  (
   const DList<T> & dlst,
   Boolean shallow = NO
   );
  
  // construct from array
  DList
  (
   const T * array,
   size_t no
   );
  
  // destructor
  ~DList();
  
  // assignment operator (deep copy)
  void operator =
  (
   const DList<T> & dlst
   );
  
  // conversion to array operator
  operator T * ();
  
  // append new item
  void Append
  (
   const T & item
   );
  
  // append an array of new items
  void Append
  (
   const T * array,
   size_t no
   );
  
  void Append
  (
   const DList<T> & dlst
   );
  
  // delete current item
  void Delete();
  
  // insert new item in current location
  void InsertBefore
  (
   const T & item
   );
  
  void InsertBefore
  (
   const T * array,
   size_t no
   );
  
  void InsertBefore
  (
   const DList<T> & dlst
   );
  
  void InsertAfter
  (
   const T & item
   );
  
  void InsertAfter
  (
   const T * array,
   size_t no
   );
  
  void InsertAfter
  (
   const DList<T> & dlst
   );
  
  // remove all items from the list
  void Erase();
  
  // get current item
  T Get();
  
  // directly reference current item
  T & operator * ();
  
  // TRUE if current item is last item
  Boolean AtHead();
  Boolean AtTail();
  
  // set current item to head of list
  void ToHead();
  void ToTail();
  
  // move to next item in list
  Boolean ToNext();
  Boolean ToPrev();
  
  // interrogate list
  size_t  GetCount();
  Boolean IsShallow();
  Boolean IsCircular();
  
 protected:
  // type defining a node in the list
  struct Node
  {
    T Data;
    Node * Next;
    Node * Prev;
  };
  
  size_t Count; // # of items in list
  Node * Head;  // first item
  Node * Tail;  // last item
  Node * Work;  // current item
  
  Boolean Shallow;  // Is this a shallow copy?
  Boolean Circular; // is this a circular list?
  
  // internal utility functions
  void DeepCopy
  (
   const DList<T> & dlst
   );
  
  void ShallowCopy
  (
   const DList<T> & dlst
   );
  
  void SetNull();
};

// implement utility functions
template <class T>
inline void DList<T>::ShallowCopy
(
 const DList<T> & dlst
 )
{
  Head  = dlst.Head;
  Tail  = dlst.Tail;
  Work  = dlst.Work;
  Count = dlst.Count;
  Shallow  = YES;
  Circular = dlst.Circular;
}

template <class T>
inline void DList<T>::SetNull()
{
  Head  = NULL;
  Tail  = NULL;
  Work  = NULL;
  Count = 0;
}

// constructors
template <class T>
inline DList<T>::DList
(
 Boolean circ
 )
{
  SetNull();
  Shallow  = NO;
  Circular = circ;
}

// destructor
template <class T>
inline DList<T>::~DList()
{
  Erase();
}

// assignment operator (deep copy)
template <class T>
void DList<T>::operator =
(
 const DList<T> & dlst
 )
{
  Erase();
  DeepCopy(dlst);
}

// TRUE if current item is last item
template <class T>
inline Boolean DList<T>::AtHead()
{
  if (Work == Head)
    return YES;
  else
    return NO;
}

template <class T>
inline Boolean DList<T>::AtTail()
{
  if (Work == Tail)
    return YES;
  else
    return NO;
}

// set current item to head of list
template <class T>
inline void DList<T>::ToHead()
{
  Work = Head;
}

template <class T>
inline void DList<T>::ToTail()
{
  Work = Tail;
}

// interrogate list
template <class T>
inline size_t DList<T>::GetCount()
{
  return Count;
}

template <class T>
inline Boolean DList<T>::IsShallow()
{
  return Shallow;
}

template <class T>
inline Boolean DList<T>::IsCircular()
{
  return Circular;
}

#endif

/*; end of file */
