//	riverelmnt.cc

#include <iostream>
#include <sstream>
#include <string.h>
#include "riverelmnt.h"
#include "dfstream.h"
#include "geometrc.h"
#include "gtool.h"
#include "node.h"
#include "rseg.h"
#include "riverpoint.h"
#include "boolean.h"
#include "error.h"

const int BUFFLEN = 256; // ե뤫ɤ߹ 1 Ԥʸ

float 
Theta2(			// ʬ p1p2 ȿʿľȤʤ٤ޤ
  Point2d& p1,		// ʬ1
  Point2d& p2		// ʬ2
)
{
  Metric dx, dy, ax, ay;
  float t;
  dx = p2.x() - p1.x();  ax = (int)fabs(dx);
  dy = p2.y() - p1.y();  ay = (int)fabs(dy);
  t = (ax + ay == 0) ? 0 : (float) dy / (ax + ay);
  if (dx < 0)  t = 2 - t;
  else if (dy < 0) t = 4 + t;
  return t * 90.;
}

void
RiverElmnt::SetNodeLList
(
 Rseg* riverp,
 DList<NodeL*>& nodepList,
 Metric xVal, Metric yVal, ElvType zVal,
 int seNodeLFlag,
 RiverPoint* rpp
 )
{
  Boolean Found = NO;	// ΡɤؤΥݥ󥿥ꥹȤ̤Ͽ
  NodeL* nodep;

  if (nodepList.GetCount() > 0) {	// ꥹȤϿƤ
    // ΡɤؤΥݥ󥿤
    nodepList.ToHead();
    while (1) {
      nodep = nodepList.Get();
      
      if (fabs(nodep->x() - xVal) < 0.0001 &&
	  fabs(nodep->y() - yVal) < 0.0001) {
	Found = YES;  break;
      }
	  
      if (nodepList.ToNext() == NO) break;
    }
  }

  if (Found == YES) {	// ꥹȤ˴Ͽ

    // Ρ()°ƻʬؤΥݥ󥿤ΥꥹȤȿ׼
    // νϿ

    Point2d nod(xVal, yVal);
    float tval = Theta2(nod, *rpp);
    RiverPoint* rp0;
    RiverPoint* rp1;
    nodep->ToHead();
    while (1) {
      Rseg* tmprseg = nodep->Get();
      if (nodep == tmprseg->StartNodeLp()) {
	if ((tmprseg->StrmpList()).GetCount() > 1) {
	  (tmprseg->StrmpList()).ToHead();
	  rp0 = (tmprseg->StrmpList()).Get();
	  if ((tmprseg->StrmpList()).ToNext() == YES)
	    rp1 = (tmprseg->StrmpList()).Get();
	}
	else { error(); abort(); }
      }
      else if (nodep == tmprseg->EndNodeLp()) {
	if ((tmprseg->StrmpList()).GetCount() > 1) {
	  (tmprseg->StrmpList()).ToTail();
	  rp0 = (tmprseg->StrmpList()).Get();
	  if ((tmprseg->StrmpList()).ToPrev() == YES)
	    rp1 = (tmprseg->StrmpList()).Get();
	}
	else { error(); abort(); }
      }
      else { error(); abort(); }
      
      float thetaval = Theta2(*rp0, *rp1);
	  
      if (tval < thetaval)
	{ nodep->InsertBefore(riverp); break; }
      else if (tval >= thetaval && nodep->ToNext() == NO)
	{ nodep->Append(riverp); break; }
		}
  }
  else {	// ꥹȤ̤Ͽ
    nodep = new NodeL;
    // Ρ()˺ɸͿ
    nodep->SetVal(xVal, yVal, zVal);
    // Ρ()°ƻʬؤΥݥ󥿤ΥꥹȤϿ
    nodep->Append(riverp);
    // ꥹȤϿ
    nodepList.Append(nodep);
  }

  // ƻʬ饹Υ֥ȤϡλؤΥݥ
  // 
  if (seNodeLFlag == 1)	// 
    riverp->SetStartNodeLp(nodep);
  else					// λ
    riverp->SetEndNodeLp(nodep);

  return;
}


// added by iYutaka (Wed Nov 13 18:17:37 2002)
//  SetNodeLList ϰۤʤ̤δؿ
void
RiverElmnt::SetNodeLList
(
 Rseg* riverp,
 DList<NodeL*>& nodepList,
 Metric xVal, Metric yVal, ElvType zVal,
 int amGB, int anGB,            // added
 int seNodeLFlag,
 RiverPoint* rpp
 )
{
    Boolean Found = NO;	// ΡɤؤΥݥ󥿥ꥹȤ̤Ͽ
    NodeL* nodep;

    if (nodepList.GetCount() > 0) {	// ꥹȤϿƤ
        // ΡɤؤΥݥ󥿤
        nodepList.ToHead();
        while (1) {
            nodep = nodepList.Get();
      
            if (fabs(nodep->x() - xVal) < 0.0001 &&
                fabs(nodep->y() - yVal) < 0.0001) {
                Found = YES;  break;
            }
	  
            if (nodepList.ToNext() == NO) break;
        }
    }

    if (Found == YES) {	// ꥹȤ˴Ͽ

        // Ρ()°ƻʬؤΥݥ󥿤ΥꥹȤȿ׼
        // νϿ

        Point2d nod(xVal, yVal);
        float tval = Theta2(nod, *rpp);
        RiverPoint* rp0;
        RiverPoint* rp1;
        nodep->ToHead();
        while (1) {
            Rseg* tmprseg = nodep->Get();
            if (nodep == tmprseg->StartNodeLp()) {
                if ((tmprseg->StrmpList()).GetCount() > 1) {
                    (tmprseg->StrmpList()).ToHead();
                    rp0 = (tmprseg->StrmpList()).Get();
                    if ((tmprseg->StrmpList()).ToNext() == YES)
                        rp1 = (tmprseg->StrmpList()).Get();
                }
                else { error(); abort(); }
            }
            else if (nodep == tmprseg->EndNodeLp()) {
                if ((tmprseg->StrmpList()).GetCount() > 1) {
                    (tmprseg->StrmpList()).ToTail();
                    rp0 = (tmprseg->StrmpList()).Get();
                    if ((tmprseg->StrmpList()).ToPrev() == YES)
                        rp1 = (tmprseg->StrmpList()).Get();
                }
                else { error(); abort(); }
            }
            else { error(); abort(); }
      
            float thetaval = Theta2(*rp0, *rp1);
	  
            if (tval < thetaval)
            { nodep->InsertBefore(riverp); break; }
            else if (tval >= thetaval && nodep->ToNext() == NO)
            { nodep->Append(riverp); break; }
        }
    }
    else {	// ꥹȤ̤Ͽ
        nodep = new NodeL;
        // Ρ()˺ɸͿ
        //     nodep->SetVal(xVal, yVal, zVal);
        // mod. by iYutaka (Wed Nov 13 18:25:48 2002)
        nodep->SetVal(xVal, yVal, zVal, amGB, anGB);
        // Ρ()°ƻʬؤΥݥ󥿤ΥꥹȤϿ
        nodep->Append(riverp);
        // ꥹȤϿ
        nodepList.Append(nodep);
    }

    // ƻʬ饹Υ֥ȤϡλؤΥݥ
    // 
    if (seNodeLFlag == 1)	// 
        riverp->SetStartNodeLp(nodep);
    else					// λ
        riverp->SetEndNodeLp(nodep);

    return;
}


void
RiverElmnt::SetRiver
(
 char* fname
)
{
	// 1.ե뤫ƻξɤ߼
	dfstream input1(fname);
	if(!input1) {
		cerr << "Cannot open " << fname << endl;
		exit(1);
	}
  
	long nVal;		// ֹѥ(ե뤫鲿ɤ߹
					// ɽ)
	int rsegNumVal;	// ƻʬֹ
	int nodeInfo;	// üΰ־
	Metric xVal, yVal;	// x, y ƺɸ
	ElvType zVal;		// z ɸ
	double wVal;		// 
	int nodeNumVal, mGBVal, nGBVal; // üֹ桢޳ֹ
	int updownFlag = 0;	// 1: up, -1: down ()
	int seNodeLFlag = 0;
	int mGBChk, nGBChk;	// ޳ֹΥå(ĤΥեο޳ֹ
						// Ȥ)
	Boolean TrackingFlag = NO;	// YES: ĤβƻʬˤĤ
								// NO : ĤβƻʬˤĤλ
	Boolean NextFlag = NO;
	RiverPoint* prevp;
	Rseg* riverp;

	while(1) {
		char buffer[BUFFLEN];  // 1 ɤ߹िʸ
		input1.getline(buffer, BUFFLEN);
		// [Data] ޤɤФ
		if (strcmp(buffer, "[Data]") == 0) break;
		if (!input1) break;
	}

	for (nVal = 0;;) {
		char buffer[BUFFLEN]; // ɤ߹िʸ
		input1.getline(buffer, BUFFLEN); // ե뤫飱ɤ߹
		if (!input1) break; // եνޤǤΤ for ʸ̤
							// 
		if (buffer[0] == '#') continue;
		// istrstream istr(buffer);
      istringstream istr((const char*)buffer);  // added Oct. 11, 2007

		// ʸ󤫤ƥǡͤɤ߹
		istr >> mGBVal >> nGBVal >> nodeNumVal >> rsegNumVal >> nodeInfo 
			 >> xVal >> yVal >> zVal >> wVal;
		if (!istr) {	// ʸ󤫤ɬ׸ĿΥǡɤ߹ʤ
						// ϥ顼
			nVal++;
			cerr << "line: " << nVal << "; Not enough data items. "
				 << endl << "RiverElmnt::SetRiver" << endl;
			abort();
		}
      
		// ޳ֹ椬ɤå
		// ĤΥեο޳ֹȤ
		if (nVal == 0) {	// ޳ֹΥåѤͤͿ
			mGBChk = mGBVal;  nGBChk = nGBVal;
		}
		if (mGBVal != mGBChk || nGBVal != nGBChk)	{	// ޳ֹ椬
														// ʤХ顼
			cerr << "line: " << nVal << "; Not equal gridbox number. "
				 << endl;
			abort();
		}

		nVal++;		// եβܤ򸽺ɤ߹
		RiverPoint* p = new RiverPoint; // ƻؤΥݥ
      
		// ƻ˳ƥǡͤͿ(޳̵ֹ뤹)
		p->SetVal(xVal, yVal, zVal, nVal);
      
		if (TrackingFlag == NO) {	// ƻʬλϤޤ
			if (nodeNumVal == 0) {
				// ƻʬϤޤäƤ饨顼
				cerr << "line: " << nVal << "; The river "
					 << "segment started from the middle point. "
					 << endl;
				abort();
			}
			else if (nodeNumVal > 0)	// ƻʬήü
										// Ϥޤ
				updownFlag = -1;
			else						// ƻʬήü
										// Ϥޤ
				updownFlag = 1;

			riverp = new Rseg;
			riverp->Number(rsegNumVal); // ƻʬФƲƻʬֹ
										// Ϳ
			TrackingFlag = YES;			// ե饰 YES ˤ
	  
			seNodeLFlag = 1;			// 
	  
			p->SetRsegNum(rsegNumVal);	// ƻФƲƻʬֹ
										// Ϳ
			riverp->StrmpList().Append(p);	// ƻʬβƻؤΥݥ
											// 󥿥ꥹȤϿ
			riverp->UpdownFlag(updownFlag); // updownFlag = 
											//  1: ήή
											// -1: ή鲼ή
			prevp = p;
			NextFlag = YES;
		}
		else {	// TrackingFlag == YES
				// ƻʬƻʬνλ()
			if (NextFlag == YES) {
				SetNodeLList(riverp, nodepList, prevp->x(), prevp->y(), 
							 prevp->z(), seNodeLFlag, p);
				NextFlag = NO;
			}
			if (nodeNumVal != 0) {	// ƻʬνλ()
				seNodeLFlag = -1;	// λ
				SetNodeLList(riverp, nodepList, xVal, yVal, zVal,
							 seNodeLFlag, prevp);

				rsegpList.Append(riverp);	// ƻʬؤΥݥ󥿥ꥹ
											// ȤϿ
				TrackingFlag = NO;	// Υ롼פϿƻʬ
			}

			p->SetRsegNum(rsegNumVal); // ƻФƲƻʬֹͿ
									   // 
			riverp->StrmpList().Append(p); // ƻʬβƻؤΥݥ
										   // ꥹȤϿ
			prevp = p;
		}
	}

	input1.close();
	return;
}

/*
void
RiverElmnt::SetDataWithGrid(
  char* fname
)
{
  // 1.ե뤫ƻξɤ߼
  dfstream input1(fname);
  if(!input1) {
    cerr << "Cannot open " << fname << endl;
    exit(1);
  }
  
  long nVal;		// ֹѥ(ե뤫鲿ɤ߹
			// ɽ)
  int rsegNumVal;	// ƻʬֹ
  Metric xVal, yVal;	// x,y ƺɸ
  ElvType zVal;		// z ɸ
  long nodeNumVal;	// ֹ
  int gxVal, gyVal;	// ʻҺɸ
  int updownFlag = 0;	// 1: up, -1: down ()
  int seNodeLFlag = 0;
  
  Boolean TrackingFlag = NO; // YES: ĤβƻʬˤĤ
			     // NO : ĤβƻʬˤĤλ
  Boolean NextFlag = NO;
  RiverPoint* prevp;
  Rseg* riverp;
  for (nVal = 0;;)
    {
      char buffer[BUFFLEN]; // ɤ߹िʸ
      input1.getline(buffer, BUFFLEN); // ե뤫飱ɤ߹
      if (!input1) break; // եνޤǤΤ for ʸ̤
      //istrstream istr(buffer);
      istringstream istr((const char*)buffer);  // added Oct. 11, 2007

      // ʸ󤫤ƥǡͤɤ߹
      istr >> nodeNumVal >> rsegNumVal
	   >> xVal >> yVal >> zVal >> gxVal >> gyVal;
      if (!istr)	// ʸ󤫤ɬ׸ĿΥǡɤ߹ʤ
			// ϥ顼
	{
	  nVal++;
	  cerr << "line: " << nVal << "; Not enough data items. "
	       << endl << RiverElmnt::SetDataWithGrid << endl;
	  abort();
	}
      
      nVal++;		// եβܤ򸽺ɤ߹
      RiverPoint* p = new RiverPoint; // ƻؤΥݥ
      
      // ƻ˳ƥǡͤͿ
      p->SetVal(xVal, yVal, zVal, nVal);
      p->SetGridCoord(gxVal, gyVal);
      p->Number(nVal);
      
      if (TrackingFlag == NO) // ƻʬλϤޤ
	{
	  if (nodeNumVal == 0)
	    {
	      // ƻʬϤޤäƤ饨顼
	      cerr << "line: " << nVal << "; The river "
		   << "segment started from the middle point. "
		   << endl;
	      abort();
	    }
	  else if (nodeNumVal > 0) // ƻʬήüϤޤ
	    updownFlag = -1;
	  else		           // ƻʬήüϤޤ
	    updownFlag = 1;
	  
	  riverp = new Rseg;
	  riverp->Number(rsegNumVal); // ƻʬФƲƻʬֹ
				      // Ϳ
	  TrackingFlag = YES;	      // եå YES ˤ
	  
	  seNodeLFlag = 1;	      // 
	  
	  p->SetRsegNum(rsegNumVal); // ƻФƲƻʬֹͿ
				     // 
	  riverp->StrmpList().Append(p);  // ƻʬβƻؤΥݥ
					  // ꥹȤϿ
	  
	  riverp->UpdownFlag(updownFlag); // updownFlag = 
					  //  1: ήή
					  // -1: ή鲼ή
	  
	  prevp = p;
	  NextFlag = YES;
	}
      else		// TrackingFlag == YES
	// ƻʬƻʬνλ()
	{
	  if (NextFlag == YES)
	    {
	      SetNodeLList(riverp, nodepList, prevp->x(), prevp->y(), 
		prevp->z(), seNodeLFlag, p);
	      NextFlag = NO;
	    }
	  if (nodeNumVal != 0) // ƻʬνλ()
	    {
	      seNodeLFlag = -1; // λ
	      SetNodeLList(riverp, nodepList, xVal, yVal, zVal,
		seNodeLFlag, prevp);
	      
	      rsegpList.Append(riverp);	// ƻʬؤΥݥ󥿥ꥹȤ
					// Ͽ
	      TrackingFlag = NO;	// Υ롼פϿƻʬ
	    }
	  
	  p->SetRsegNum(rsegNumVal); // ƻФƲƻʬֹ
	  riverp->StrmpList().Append(p); // ƻʬβƻؤΥݥ
					 // ꥹȤϿ
	  
	  prevp = p;
	}
    }			// match : for (nVal = 0;;)
  
  input1.close();
  return;
}
*/

void
RiverElmnt::SetDataWithGrid
(
 char* fname
 )
{
  // 1.ե뤫ƻξɤ߼
  dfstream input1(fname);
  if(!input1) {
    cerr << "Cannot open " << fname << endl;
    exit(1);
  }

  long nVal = 0; // ֹѥ
  int readNum = 0; // ե뤫鲿ɤ߹
  int rsegNumVal;	// ƻʬֹ()
  int rVal;		// ƻʬֹ(ɤ߹)
  Metric xVal, yVal;	// x,y ƺɸ
  ElvType zVal;		// z ɸ
  long nodeNumVal;	// ֹ
  int gxVal, gyVal;	// ʻҺɸ
  int updownFlag = 0;	// 1: up, -1: down ()
  
  Rseg* riverp;
  DList<RiverPoint*> rpList;	// ƻΥꥹ

  // ޤԤɤ
  char buffer[BUFFLEN]; // ɤ߹िʸ
  input1.getline(buffer, BUFFLEN); // ե뤫飱ɤ߹
  if (!input1) {
    cerr << "There is no data in input file." << endl;
    exit(1);
  }
  // istrstream istr(buffer);
  istringstream istr((const char*)buffer);  // added Oct. 11, 2007

  // ʸ󤫤ƥǡͤɤ߹
  istr >> nodeNumVal >> rVal
    >> xVal >> yVal >> zVal >> gxVal >> gyVal;
  if (!istr) {	// ʸ󤫤ɬ׸ĿΥǡɤ߹
    // ʤϥ顼
    readNum++;
    cerr << "line: " << readNum << "; Not enough data items. "
      << endl << "RiverElmnt::SetDataWithGrid" << endl;
    abort();
  }

  nVal++;
  readNum++;	// եβܤ򸽺ɤ߹
  RiverPoint* p = new RiverPoint; // ƻؤΥݥ
  
  // ƻ˳ƥǡͤͿ
  p->SetVal(xVal, yVal, zVal, nVal);
  p->SetGridCoord(gxVal, gyVal);
  p->SetRsegNum(rVal);	// ƻФƲƻʬֹͿ
  rpList.Append(p);	// ƻʬβƻؤΥݥ󥿥ꥹȤϿ
  if (nodeNumVal == 0) {
    // ƻʬϤޤäƤ饨顼
    cerr << "line: " << readNum << "; The river "
      << "segment started from the middle point. "
	<< endl;
    abort();
  }
  else if (nodeNumVal > 0) // ƻʬήüϤޤ
    updownFlag = -1;
  else			           // ƻʬήüϤޤ
    updownFlag = 1;

  riverp = new Rseg;
  riverp->Number(rVal);	// ƻʬФƲƻʬֹͿ
  riverp->UpdownFlag(updownFlag); // updownFlag = 1: ή
  // ή -1: ή鲼ή
  rsegNumVal = rVal;		// ƻʬֹ򵭲

  for (;;) {
    input1.getline(buffer, BUFFLEN); // ե뤫飱ɤ߹
    if (!input1) break; // եνޤǤΤ for ʸ̤
    // istrstream istr0(buffer);
    istringstream istr0((const char*)buffer);  // added Oct. 11, 2007

    // ʸ󤫤ƥǡͤɤ߹
    istr0 >> nodeNumVal >> rVal
      >> xVal >> yVal >> zVal >> gxVal >> gyVal;
    if (!istr0) {	// ʸ󤫤ɬ׸ĿΥǡɤ߹ʤ
      // ϥ顼
      readNum++;
      cerr << "line: " << readNum << "; Not enough data items. "
	<< endl << "RiverElmnt::SetDataWithGrid" << endl;
      abort();
    }
      
    nVal++;
    readNum++;	// եβܤ򸽺ɤ߹
    RiverPoint* pp = new RiverPoint; // ƻؤΥݥ

    // ƻ˳ƥǡͤͿ
    pp->SetVal(xVal, yVal, zVal, nVal);
    pp->SetGridCoord(gxVal, gyVal);
    pp->SetRsegNum(rVal); // ƻФƲƻʬֹͿ

    if (rVal != rsegNumVal) { // ƻʬλϤޤ
//      if (rpList.GetCount() == 1) { // ǡĤʤ
//	cerr << "The river point is only one." << endl;
//	cerr << "RiverElmnt::SetDataWithGrid" << endl;
//	abort();
//      }
      riverp->StrmpList(rpList);	// ƻꥹȤϤ
      rsegpList.Append(riverp);	// ƻʬؤΥݥ󥿥ꥹȤϿ
      rpList.Erase();				// ꥹȤõ
      rpList.Append(pp);			// ƻꥹȤϿ
      rsegNumVal = rVal;			// ƻʬֹ򵭲
      riverp = new Rseg;
      riverp->Number(rVal); // ƻʬФƲƻʬֹͿ
      if (nodeNumVal == 0) {
	// ƻʬϤޤäƤ饨顼
	cerr << "line: " << nVal << "; The river "
	  << "segment started from the middle point. "
	    << endl; abort();
      }
      else if (nodeNumVal > 0)	// ƻʬήüϤޤ
	updownFlag = -1;
      else			// ƻʬήüϤޤ
	updownFlag = 1;

      riverp->UpdownFlag(updownFlag); // updownFlag = 
      //  1: ήή
      // -1: ή鲼ή
    }
    else {	// ƻʬƻʬνλ()
      rpList.Append(pp);	// ƻꥹȤϿ
    }
  }
//  if (rpList.GetCount() == 1) { // ǡĤʤ
//    cerr << "The river point is only one." << endl;
//    cerr << "RiverElmnt::SetDataWithGrid" << endl;
//    abort();
//  }
  riverp->StrmpList(rpList);	// ƻꥹȤϤ
  rsegpList.Append(riverp);	// ƻʬؤΥݥ
  
  // 2. üΥꥹȤüϿ
  if (rsegpList.GetCount() > 0) {
    rsegpList.ToHead();
    while (1) {
      riverp = rsegpList.Get();
      rpList = riverp->StrmpList();
      RiverPoint** rparray = (RiverPoint**)rpList;
      int count = (int)rpList.GetCount();
//       SetNodeLList(riverp, nodepList, rparray[0]->x(), rparray[0]->y(), 
// 		   rparray[0]->z(), 1, rparray[1]);
//       SetNodeLList(riverp, nodepList, rparray[count - 1]->x(),
// 		   rparray[count - 1]->y(), rparray[count - 1]->z(),
// 		   - 1, rparray[count - 2]);

      // mod. by iYutaka (Wed Nov 13 18:16:41 2002)
      SetNodeLList(riverp, 
                   nodepList, 
                   rparray[0]->x(), 
                   rparray[0]->y(), 
		   rparray[0]->z(), 
                   rparray[0]->MGB(), // added
                   rparray[0]->NGB(), // added
                   1, 
                   rparray[1]);

      SetNodeLList(riverp, 
                   nodepList, 
                   rparray[count - 1]->x(),
		   rparray[count - 1]->y(), 
                   rparray[count - 1]->z(),
                   rparray[count - 1]->MGB(), // added
                   rparray[count - 1]->NGB(), // added
		   -1, 
                   rparray[count - 2]);

      if (rsegpList.ToNext() == NO) break;
    }
  }
  input1.close();
  return;
}

void
RiverElmnt::SetDataWithNumber(
  char* fname
)
{
  // 1.ե뤫ƻξɤ߼
  dfstream input1(fname);
  if(!input1) {
    cerr << "Cannot open " << fname << endl;
    exit(1);
  }
  
  long nVal;		// ֹѥ(ե뤫鲿ɤ߹
			// ɽ)
  int rsegNumVal = 0;	// ƻʬֹѥ
  Metric xVal, yVal;	// x,y ƺɸ
  ElvType zVal;		// z ɸ
  long nodeNumVal, numVal; // ֹ桢ֹ
  int updownFlag = 0;	// 1: up, -1: down ()
  int seNodeLFlag = 0;

  Boolean TrackingFlag = NO; // YES: ĤβƻʬˤĤ
			     // NO : ĤβƻʬˤĤλ
  Boolean NextFlag = NO;
  RiverPoint* prevp;
  Rseg* riverp;
  for (nVal = 0;;)
    {
      char buffer[BUFFLEN]; // ɤ߹िʸ
      input1.getline(buffer, BUFFLEN); // ե뤫飱ɤ߹
      if (!input1) break; // եνޤǤΤ for ʸ̤
      // istrstream istr(buffer);
      istringstream istr((const char*)buffer);  // added Oct. 11, 2007

      // ʸ󤫤ƥǡͤɤ߹
      istr >> numVal >> nodeNumVal 
	   >> xVal >> yVal >> zVal;
      if (!istr)	// ʸ󤫤ɬ׸ĿΥǡɤ߹ʤ
			// ϥ顼
	{
	  nVal++;
	  cerr << "line: " << nVal << "; Not enough data items. "
	       << endl << "RiverElmnt::SetDataWithNumber" << endl;
	  abort();
	}
      
      nVal++;		// եβܤ򸽺ɤ߹
      RiverPoint* p = new RiverPoint; // ƻؤΥݥ
      
      // ƻ˳ƥǡͤ
      p->SetVal(xVal, yVal, zVal, nVal);
      p->Number(numVal);
      
      if (TrackingFlag == NO) // ƻʬλϤޤ
	{
	  if (nodeNumVal == 0)
	    {
	      // ƻʬϤޤäƤ饨顼
	      cerr << "line: " << nVal << "; The river "
		   << "segment started from the middle point. "
		   << endl;
	      abort();
	    }
	  else if (nodeNumVal > 0) // ƻʬήüϤޤ
	    updownFlag = -1;
	  else		           // ƻʬήüϤޤ
	    updownFlag = 1;
	  
	  riverp = new Rseg;
	  rsegNumVal++;	              // ƻʬֹ򹹿
	  riverp->Number(rsegNumVal); // ƻʬФƲƻʬֹ
				      // Ϳ
	  TrackingFlag = YES;	      // եå YES ˤ
	  
	  seNodeLFlag = 1;	      // 
	  
	  p->SetRsegNum(rsegNumVal); // ƻФƲƻʬֹͿ
				     // 
	  riverp->StrmpList().Append(p);  // ƻʬβƻؤΥݥ
					  // ꥹȤϿ
	  
	  riverp->UpdownFlag(updownFlag); // updownFlag = 
					  //  1: ήή
					  // -1: ή鲼ή
	  
	  prevp = p;
	  NextFlag = YES;
	}
      else		// TrackingFlag == YES
	// ƻʬƻʬνλ()
	{
	  if (NextFlag == YES)
	    {
	      SetNodeLList(riverp, nodepList, prevp->x(), prevp->y(), 
		prevp->z(), seNodeLFlag, p);
	      NextFlag = NO;
	    }
	  if (nodeNumVal != 0) // ƻʬνλ()
	    {
	      seNodeLFlag = -1; // λ
	      SetNodeLList(riverp, nodepList, xVal, yVal, zVal,
		seNodeLFlag, prevp);
	      
	      rsegpList.Append(riverp);	// ƻʬؤΥݥ󥿥ꥹȤ
					// Ͽ
	      TrackingFlag = NO;	// Υ롼פϿƻʬ
	    }
	  
	  p->SetRsegNum(rsegNumVal); // ƻФƲƻʬֹͿ
				     // 
	  riverp->StrmpList().Append(p); // ƻʬβƻؤΥݥ
					 // ꥹȤϿ
	  
	  prevp = p;
	}
    }			// match : for (nVal = 0;;)
  
  input1.close();
  return;
}

void
RiverElmnt::Print(ostream& dst)
{
  dst << "# GridNumber GridNumber X Y Z RivSegNumber\n" << endl;

  if (rsegpList.GetCount() != 0) 
    {
      rsegpList.ToHead();
      while (1)
		{
		  (rsegpList.Get())->Print(dst); 
		  dst << "\n";
		  if (rsegpList.ToNext() == NO) break;
		}
    }
  else
    {
      cerr << "Error(riverelmnt.h) : No list exists." << endl;
      exit(1);
    }

  dst << "# X Y Z RivSegNumber..." << endl;

  NodeL* node;
  if (nodepList.GetCount() != 0) 
    {
      nodepList.ToHead();
      while (1)
	{
	  node = nodepList.Get();
	  dst << node->x() << " " << node->y() << " " << node->z() << " ";
	  
	  if (node->GetCount() != 0)
	    {
	      node->ToHead();
	      while (1)
		{
		  dst << (node->Get())->Number() << " ";
		  if (node->ToNext() == NO) break;
		}
	    }
	  else
	    {
	      cerr << "Error(riverelmnt.h) : No rsList exists." << endl;
	      exit(1);
	    }

	  dst << "\n";
	  if (nodepList.ToNext() == NO) break;
	}
    }
  else
    {
      cerr << "Error(riverelmnt.h) : No list exists." << endl;
      error(); abort();
    }

  return;
}

void
RiverElmnt::RemakeNumber()
{
  int num = 1;
  if (nodepList.GetCount() == 0) { error(); abort(); }
  
  nodepList.ToHead();
  while (1)
    {
      NodeL* tmpnode = nodepList.Get();
      tmpnode->Number(num);
      num++;
      
      if (nodepList.ToNext() == NO) break;
    }

  if (rsegpList.GetCount() == 0) { error(); abort(); }
  rsegpList.ToHead();
  while (1)
    {
      Rseg* tmprseg = rsegpList.Get();
      DList<RiverPoint*>& strmList = tmprseg->StrmpList();
      
      if (strmList.GetCount() == 0) { error(); abort(); }
      
      strmList.ToHead();
      while (1)
	{
	  RiverPoint* tmprp = strmList.Get();
	  if (strmList.AtHead() == YES)	// Ϥ
	    tmprp->Number((tmprseg->StartNodeLp())->Number());
	  else if (strmList.AtTail() == YES) // 
	    tmprp->Number((tmprseg->EndNodeLp())->Number());
	  else			// 
	    tmprp->Number(num++);
	  if (strmList.ToNext() == NO) break;
	}
      
      if (rsegpList.ToNext() == NO) break;
    }

  return;
}

void
RiverElmnt::ResetRiverPoint()
{
  if (nodepList.GetCount() == 0) return;
  nodepList.ToHead();
  while (1)
    {
      NodeL* tmpnode = nodepList.Get();
      if (tmpnode->GetCount() > 1)
	{
	  tmpnode->ToHead();
	  Rseg* tmprseg = tmpnode->Get();
	  DList<RiverPoint*>& rpList = tmprseg->StrmpList();
	  RiverPoint* tmprp;
	  if (tmprseg->StartNodeLp() == tmpnode)
	    {
	      rpList.ToHead();
	      tmprp = rpList.Get();
	    }
	  else
	    {
	      rpList.ToTail();
	      tmprp = rpList.Get();
	    }
	  if (tmpnode->ToNext() == NO) { error(); abort(); }
	  
	  while (1)
	    {
	      tmprseg = tmpnode->Get();
	      if (tmprseg->StartNodeLp() == tmpnode)
		{
		  rpList.ToHead();
		  RiverPoint* delrp = rpList.Get();
		  rpList.Delete();
		  delete delrp;
		  rpList.InsertBefore(tmprp);
		}
	      else
		{
		  rpList.ToTail();
		  RiverPoint* delrp = rpList.Get();
		  rpList.Delete();
		  delete delrp;
		  rpList.InsertAfter(tmprp);
		}
	      if (tmpnode->ToNext() == NO) break;
	    }
	}
      if (nodepList.ToNext() == NO) break;
    }
  
  return;
}
